fix bug after a bash completion
[errhandle.git] / err
diff --git a/err b/err
index 5d62d67bc1e0d1154eb3a163a91a1e625c3784da..5d15407638146dedb81aa36783940e8efb8edcf4 100644 (file)
--- a/err
+++ b/err
@@ -1,18 +1,6 @@
 #!/bin/bash
-# Copyright 2018 Ian Kelling
-
-# Licensed under the Apache License, Version 2.0 (the "License");
-# you may not use this file except in compliance with the License.
-# You may obtain a copy of the License at
-
-# http://www.apache.org/licenses/LICENSE-2.0
-
-# Unless required by applicable law or agreed to in writing, software
-# distributed under the License is distributed on an "AS IS" BASIS,
-# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
-# See the License for the specific language governing permissions and
-# limitations under the License.
-
+# Copyright (C) 2019 Ian Kelling
+# SPDX-License-Identifier: GPL-3.0-or-later
 
 # Commentary: Bash stack trace and error handling functions. This file
 # is meant to be sourced. It loads some functions which you may want to
 # runs err-catch. See the README file for a slightly longer explanation.
 
 
-#######################################
-# Undoes err-catch. turns off exit and stack trace on error.
-#######################################
-err-allow() {
-  set +E +o pipefail; trap ERR
-}
-
-
 #######################################
 # Print stack trace
 #
-# usage: err-bash-trace [FRAME_START]
+# usage: err-bash-trace [MESSAGE]
+#
+# This function is called by the other functions which print stack
+# traces.
 #
 # It does not show function args unless you first run:
 # shopt -s extdebug
-# which err-catch & err-print does for you.
+# which err-catch & err-print do for you.
+#
+# MESSAGE       Message to print just before the stack trace.
 #
-# FRAME_START   The frame to start printing on. default=0. Useful when
-#               printing from an ERR trap function to avoid printing
-#               that function.
+# _frame_start  Optional variable to set before calling. The frame to
+#               start printing on. default=1. Useful when printing from
+#               an ERR trap function to avoid printing that function.
 #######################################
 err-bash-trace() {
-  local -i argc_index=0 frame i start=${1:-0} max_indent=8 indent
+  local -i argc_index=0 frame i start=${_frame_start:-1}
   local source
-  local extdebug=false
-  if [[ $(shopt -p extdebug) == *-s* ]]; then
-    extdebug=true
+  if [[ $1 ]]; then
+    printf "%s\n" "$1"
   fi
-  for ((frame=0; frame < ${#FUNCNAME[@]}-1; frame++)); do
+  for ((frame=0; frame < ${#FUNCNAME[@]}; frame++)); do
     argc=${BASH_ARGC[frame]}
     argc_index+=$argc
-    ((frame <= start)) && continue
+    ((frame < start)) && continue
     if (( ${#BASH_SOURCE[@]} > 1 )); then
-      source="${BASH_SOURCE[frame+1]}:${BASH_LINENO[frame]}:"
+      source="${BASH_SOURCE[frame]}:${BASH_LINENO[frame-1]}:"
     fi
-    indent=$((frame-start))
-    indent=$((indent < max_indent ? indent : max_indent))
-    printf "%${indent}s↳%sin \`%s" '' "$source" "${FUNCNAME[frame]}"
-    if $extdebug; then
+    printf "  from %sin \`%s" "$source" "${FUNCNAME[frame]}"
+    if shopt extdebug >/dev/null; then
       for ((i=argc_index-1; i >= argc_index-argc; i--)); do
         printf " %s" "${BASH_ARGV[i]}"
       done
@@ -72,25 +54,120 @@ err-bash-trace() {
 # On error print stack trace and exit
 #
 # Globals:
-#   ${_errcatch_cleanup[@]}  Optional command & args that will run before exiting
+#   errcatch-cleanup  If set, this command will run just before exiting.
 #######################################
 err-catch() {
-  set -E; shopt -s extdebug
+  set -E;
+  # This condition avoids starting the bash debugger in the case that
+  # this is sourced from a startup file, and you use a login shell to
+  # run a command. eg: bash -l some-command. Avoid doing that if you want
+  # function arguments in your trace.
+  if ! shopt login_shell >/dev/null; then
+    shopt -s extdebug
+  fi
   _err-trap() {
     err=$?
     exec >&2
     set +x
-    echo "${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
-    err-bash-trace 2
+    local msg="${BASH_SOURCE[1]}:${BASH_LINENO[0]}: \`$BASH_COMMAND' returned $err"
+    if (( ${#FUNCNAME[@]} > 2 )); then
+      local _frame_start=2
+      err-bash-trace "$msg"
+    else
+      echo "$msg"
+    fi
     set -e # err trap does not work within an error trap
-    "${_errcatch_cleanup[@]:-:}" # note :-: is to be compatible with set -u
-    echo "$0: exiting with code $err"
+    if type -t errcatch-cleanup >/dev/null; then
+      errcatch-cleanup
+    fi
+    echo "$0: exiting with status $err"
     exit $err
   }
   trap _err-trap ERR
   set -o pipefail
 }
 
+
+#######################################
+# Internal function for err-catch-interactive.
+# Prints stack trace from interactive shell trap.
+# Usage: see err-catch-interactive
+#######################################
+
+_err-bash-trace-interactive() {
+  if (( ${#FUNCNAME[@]} <= 1 )); then
+    return 0
+  fi
+
+  for pattern in "${err_catch_ignore[@]}"; do
+    # shellcheck disable=SC2053
+    if [[ ${BASH_SOURCE[1]} == $pattern ]]; then
+      return 0
+    fi
+  done
+
+  local ret bash_command argc pattern i last
+  last=$_err_func_last
+  _err_func_last=${#FUNCNAME[@]}
+  # We have these passed to us because they are lost inside the
+  # function.
+  ret=$1
+  bash_command="$2"
+  argc=$(( $3 - 1 ))
+  shift 3
+  argv=("$@")
+  # The trap returns a nonzero, then gets called again. This condition
+  # tells us if we are the first.
+  if (( _err_func_last > last  )); then
+    echo ERR: \`$bash_command\' returned $ret
+  fi
+  printf "  from \`%s" "${FUNCNAME[1]}"
+  if shopt extdebug >/dev/null; then
+    for ((i=argc; i >= 0; i--)); do
+      printf " %s" "${argv[i]}"
+    done
+  fi
+  printf "\' defined at %s:%s\n" "${BASH_SOURCE[1]}" "$(declare -F "${FUNCNAME[1]}"|awk "{print \$2}")"
+  return $ret
+}
+
+#######################################
+# For interactive shells: on error, print stack trace and return
+#
+# Note: calling line number is not available, so we print function
+# definition lines.
+#
+# Globals:
+#   err_catch_ignore  Array containing glob patterns to test against filenames to ignore
+#                     errors from. Initialized to ignore bash-completion scripts on debian
+#                     based systems.
+#   _err_func_last    Used internally in err-bash-trace-interactive
+#
+#######################################
+err-catch-interactive() {
+  if ! test ${err_catch_ignore+defined}; then
+    err_catch_ignore=(
+      '/etc/bash_completion.d/*'
+      '*/bash-completion/*'
+    )
+  fi
+  declare -i _err_func_last=0
+  set -E; shopt -s extdebug
+  # shellcheck disable=SC2154
+  trap '_err-bash-trace-interactive $? "$BASH_COMMAND" ${BASH_ARGC[0]} "${BASH_ARGV[@]}" || return $?' ERR
+  set -o pipefail
+}
+
+
+#######################################
+# Undo err-catch/err-catch-interactive
+#######################################
+err-allow() {
+  shopt -u extdebug
+  set +E +o pipefail
+  trap ERR
+}
+
 #######################################
 # On error, print stack trace
 #######################################
@@ -113,7 +190,7 @@ err-print() {
 
 
 #######################################
-# On error, print stack trace
+# Print stack trace and exit
 #
 # Use this instead of the exit command to be more informative.
 #
@@ -144,4 +221,8 @@ err-exit() {
 }
 
 # We want this more often than not, so run it now.
-err-catch
+if [[ $- == *i* ]]; then
+  err-catch-interactive
+else
+  err-catch
+fi